﻿EXPORT Functions := MODULE

   EXPORT BlockRelationships := RECORD
	   unsigned2 fromblocknum;
		 unsigned2 toblocknum;
	 END;
	 
	 EXPORT rBlock := record
		unsigned2 blocknum;
	 end;

	 
	 EXPORT rBlock tBlock(rBlock l, integer c) := TRANSFORM
		self.blocknum := c;
	 end;

   EXPORT rColBlocks := record
	  unsigned1 colnum;
		unsigned2 blocknum;
	 end;

   EXPORT rRowBlocks := record
	  unsigned1 rownum;
		unsigned2 blocknum;
	 end;
	 
   EXPORT rBoxBlocks := record
	  unsigned1 boxnum;
		unsigned2 blocknum;
		unsigned2 stacknum;
		unsigned2 bandnum;
	 end;

   EXPORT rBlockCoords := record
		unsigned2 blocknum;
	  unsigned1 boxnum := 0;
	  unsigned1 rownum := 0;
	  unsigned1 colnum := 0;
	 end;

  EXPORT Blocks(integer1 blockrows=9, integer1 blockcolumns=9) := FUNCTION
      dBlockStart := dataset([{1}], rBlock);
	    return normalize(dBlockStart, blockrows*blockcolumns, tBlock(left, counter));
	END;

  EXPORT Relationships(integer1 blockrows=9, integer1 blockcolumns=9, integer1 bandsize=3, integer1 stacksize=3) := FUNCTION

		 dBlocks := Blocks(blockrows, blockcolumns);
		 
     SRows := project(dBlocks, transform(rRowBlocks, self.rownum := (unsigned)((left.blocknum-1) / blockcolumns)+1, self.blocknum := left.blocknum));
     SCols := project(dBlocks, transform(rColBlocks, self.colnum := ((left.blocknum-1) % blockrows)+1, self.blocknum := left.blocknum));
     SBoxes := project(dBlocks, transform(rBoxBlocks, self.bandnum := (((unsigned)(left.blocknum-1) / (stacksize * blockrows))), self.stacknum := (((integer)(left.blocknum-1)/ bandsize)%stacksize+1),
		                                 self.boxnum := (self.bandnum*stacksize) + self.stacknum, self.blocknum := left.blocknum));
		 // each cell, calc it's col and generate a relationship to same col cells.
     // 		 
		 // each cell, calc it's block and generate a relationship to same block cells.
		 BlockCoords1 := join(dBlocks, sRows, left.blocknum=right.blocknum, transform(rBlockCoords, self := right, self := left), hash, lookup);
		 BlockCoords2 := join(BlockCoords1, sCols, left.blocknum=right.blocknum, transform(rBlockCoords, self := right, self := left), hash, lookup);
		 BlockCoords3 := join(BlockCoords2, SBoxes, left.blocknum=right.blocknum, transform(rBlockCoords, self := right, self := left), hash, lookup);
		 
		 BlockRels1 := join(BlockCoords3, SRows, left.rownum=right.rownum, transform(BlockRelationships, self.fromblocknum := left.blocknum, self.toblocknum := right.blocknum), hash);
		 BlockRels2 := join(BlockCoords3, SCols, left.colnum=right.colnum, transform(BlockRelationships, self.fromblocknum := left.blocknum, self.toblocknum := right.blocknum), hash);
		 BlockRels3 := join(BlockCoords3, SBoxes, left.boxnum=right.boxnum, transform(BlockRelationships, self.fromblocknum := left.blocknum, self.toblocknum := right.blocknum), hash);
		 
		 return dedup(sort((BlockRels1 + BlockRels2 + BlockRels3)(fromblocknum != toblocknum), fromblocknum, toblocknum), fromblocknum, toblocknum);
	
	END;


END;